package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.entity.Order;
import com.gxwebsoft.shop.service.DealerCapitalService;
import com.gxwebsoft.shop.entity.DealerCapital;
import com.gxwebsoft.shop.param.DealerCapitalParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.OrderService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 分销商资金明细表控制器
 *
 * @author 科技小王子
 * @since 2024-07-28 11:57:41
 */
@Api(tags = "分销商资金明细表管理")
@RestController
@RequestMapping("/api/shop/dealer-capital")
public class DealerCapitalController extends BaseController {
    @Resource
    private DealerCapitalService dealerCapitalService;
    @Resource
    private OrderService orderService;

    @ApiOperation("分页查询分销商资金明细表")
    @GetMapping("/page")
    public ApiResult<PageResult<DealerCapital>> page(DealerCapitalParam param) {
        // 使用关联查询
        return success(dealerCapitalService.pageRel(param));
    }

    @ApiOperation("查询全部分销商资金明细表")
    @GetMapping("/list-for-user")
    public ApiResult<?> listForUser(DealerCapitalParam param) {
        if (getLoginUser() != null) param.setUserId(getLoginUserId());
        else return fail("请先登录");
        // 使用关联查询
        List<DealerCapital> dealerCapitalList = dealerCapitalService.listRel(param);
        if (!dealerCapitalList.isEmpty()) {
            for (DealerCapital dealerCapital : dealerCapitalList) {
                dealerCapital.setOrder(orderService.getById(dealerCapital.getOrderId()));
            }
        }
        return success(dealerCapitalList);
    }

    @ApiOperation("查询全部分销商资金明细表")
    @GetMapping()
    public ApiResult<List<DealerCapital>> list(DealerCapitalParam param) {
        // 使用关联查询
        return success(dealerCapitalService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:dealerCapital:list')")
    @ApiOperation("根据id查询分销商资金明细表")
    @GetMapping("/{id}")
    public ApiResult<DealerCapital> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(dealerCapitalService.getByIdRel(id));
    }

    @ApiOperation("添加分销商资金明细表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody DealerCapital dealerCapital) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
            dealerCapital.setUserId(loginUser.getUserId());
        }
        if (dealerCapitalService.save(dealerCapital)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改分销商资金明细表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody DealerCapital dealerCapital) {
        if (dealerCapitalService.updateById(dealerCapital)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除分销商资金明细表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (dealerCapitalService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加分销商资金明细表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<DealerCapital> list) {
        if (dealerCapitalService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改分销商资金明细表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<DealerCapital> batchParam) {
        if (batchParam.update(dealerCapitalService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除分销商资金明细表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (dealerCapitalService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
